require 'thor'
require 'certflare/version'
require 'certflare/commands'
require 'certflare/common/authenticator'
require 'certflare/common/cleanup'
module Certflare
  class CLI < Thor
    desc '--version, -v', 'returns version and exits'
    def __version
      puts Certflare::VERSION
    end
    map ['-v', '--version'] => :__version
    desc 'cert [subcommand] [options]', 'cert actions'
    subcommand('cert', Certflare::Commands::Cert)
  end
  class HookCLI < Thor
    desc '--version, -v', 'returns version and exits'
    def __version
      puts Certflare::VERSION
    end
    map ['-v', '--version'] => :__version

    desc 'auth [options]', 'Authenticate with cloudflare and create records for verfication'
    def auth
      auther = Certflare::Authenticator.new
      auther.create_txt_record
      auther.create_cleanup
      sleep 20
    end

    desc 'clean [options]', 'Cleanup cloudflare records and files'
    def clean
      cleanup = Certflare::CleanUp.new
      cleanup.get_certbot_vars
      cleanup.get_domain
      cleanup.remove_zone_id
      cleanup.remove_record_id
      cleanup.remove_txt_record
    end
  end
end